--- title: istioctl description: Istio control interface. generator: pkg-collateral-docs number_of_entries: 28 ---

Istio configuration command line utility for service operators to debug and diagnose their Istio mesh.

Flags | Shorthand | Description
--- | --- | ---
`--context <string>` |  | The name of the kubeconfig context to use (default ``)
`--istioNamespace <string>` | `-i` | Istio system namespace (default `istio-system`)
`--kubeconfig <string>` | `-c` | Kubernetes configuration file (default ``)
`--log_as_json` |  | Whether to format output as JSON or in plain console-friendly format
`--log_caller <string>` |  | Comma-separated list of scopes for which to include caller information, scopes can be any of [ads, default, kube-converter, meshconfig, model, rbac] (default ``)
`--log_output_level <string>` |  | Comma-separated minimum per-scope logging level of messages to output, in the form of <scope>:<level>,<scope>:<level>,... where scope can be one of [ads, default, kube-converter, meshconfig, model, rbac] and level can be one of [debug, info, warn, error, fatal, none] (default `default:info`)
`--log_rotate <string>` |  | The path for the optional rotating log file (default ``)
`--log_rotate_max_age <int>` |  | The maximum age in days of a log file beyond which the file is rotated (0 indicates no limit) (default `30`)
`--log_rotate_max_backups <int>` |  | The maximum number of log file backups to keep before older files are deleted (0 indicates no limit) (default `1000`)
`--log_rotate_max_size <int>` |  | The maximum size in megabytes of a log file beyond which the file is rotated (default `104857600`)
`--log_stacktrace_level <string>` |  | Comma-separated minimum per-scope logging level at which stack traces are captured, in the form of <scope>:<level>,<scope:level>,... where scope can be one of [ads, default, kube-converter, meshconfig, model, rbac] and level can be one of [debug, info, warn, error, fatal, none] (default `default:none`)
`--log_target <stringArray>` |  | The set of paths where to output the log. This can be any path as well as the special values stdout and stderr (default `[stdout]`)
`--namespace <string>` | `-n` | Config namespace (default ``)
`--platform <string>` | `-p` | Istio host platform (default `kube`)

## istioctl authn

A group of commands used to interact with Istio authentication policies. tls-check

Flags | Shorthand | Description
--- | --- | ---
`--context <string>` |  | The name of the kubeconfig context to use (default ``)
`--istioNamespace <string>` | `-i` | Istio system namespace (default `istio-system`)
`--kubeconfig <string>` | `-c` | Kubernetes configuration file (default ``)
`--log_as_json` |  | Whether to format output as JSON or in plain console-friendly format
`--log_caller <string>` |  | Comma-separated list of scopes for which to include caller information, scopes can be any of [ads, default, kube-converter, meshconfig, model, rbac] (default ``)
`--log_output_level <string>` |  | Comma-separated minimum per-scope logging level of messages to output, in the form of <scope>:<level>,<scope>:<level>,... where scope can be one of [ads, default, kube-converter, meshconfig, model, rbac] and level can be one of [debug, info, warn, error, fatal, none] (default `default:info`)
`--log_rotate <string>` |  | The path for the optional rotating log file (default ``)
`--log_rotate_max_age <int>` |  | The maximum age in days of a log file beyond which the file is rotated (0 indicates no limit) (default `30`)
`--log_rotate_max_backups <int>` |  | The maximum number of log file backups to keep before older files are deleted (0 indicates no limit) (default `1000`)
`--log_rotate_max_size <int>` |  | The maximum size in megabytes of a log file beyond which the file is rotated (default `104857600`)
`--log_stacktrace_level <string>` |  | Comma-separated minimum per-scope logging level at which stack traces are captured, in the form of <scope>:<level>,<scope:level>,... where scope can be one of [ads, default, kube-converter, meshconfig, model, rbac] and level can be one of [debug, info, warn, error, fatal, none] (default `default:none`)
`--log_target <stringArray>` |  | The set of paths where to output the log. This can be any path as well as the special values stdout and stderr (default `[stdout]`)
`--namespace <string>` | `-n` | Config namespace (default ``)
`--platform <string>` | `-p` | Istio host platform (default `kube`)

### Examples

    # Check whether TLS setting are matching between authentication policy and destination rules:
    istioctl authn tls-check

## istioctl authn tls-check

Requests Pilot to check for what authentication policy and destination rule it uses for each service in service registry, and check if TLS settings are compatible between them.

    istioctl authn tls-check [<service>] [flags]

Flags | Shorthand | Description
--- | --- | ---
`--context <string>` |  | The name of the kubeconfig context to use (default ``)
`--istioNamespace <string>` | `-i` | Istio system namespace (default `istio-system`)
`--kubeconfig <string>` | `-c` | Kubernetes configuration file (default ``)
`--log_as_json` |  | Whether to format output as JSON or in plain console-friendly format
`--log_caller <string>` |  | Comma-separated list of scopes for which to include caller information, scopes can be any of [ads, default, kube-converter, meshconfig, model, rbac] (default ``)
`--log_output_level <string>` |  | Comma-separated minimum per-scope logging level of messages to output, in the form of <scope>:<level>,<scope>:<level>,... where scope can be one of [ads, default, kube-converter, meshconfig, model, rbac] and level can be one of [debug, info, warn, error, fatal, none] (default `default:info`)
`--log_rotate <string>` |  | The path for the optional rotating log file (default ``)
`--log_rotate_max_age <int>` |  | The maximum age in days of a log file beyond which the file is rotated (0 indicates no limit) (default `30`)
`--log_rotate_max_backups <int>` |  | The maximum number of log file backups to keep before older files are deleted (0 indicates no limit) (default `1000`)
`--log_rotate_max_size <int>` |  | The maximum size in megabytes of a log file beyond which the file is rotated (default `104857600`)
`--log_stacktrace_level <string>` |  | Comma-separated minimum per-scope logging level at which stack traces are captured, in the form of <scope>:<level>,<scope:level>,... where scope can be one of [ads, default, kube-converter, meshconfig, model, rbac] and level can be one of [debug, info, warn, error, fatal, none] (default `default:none`)
`--log_target <stringArray>` |  | The set of paths where to output the log. This can be any path as well as the special values stdout and stderr (default `[stdout]`)
`--namespace <string>` | `-n` | Config namespace (default ``)
`--platform <string>` | `-p` | Istio host platform (default `kube`)

### Examples

    # Check settings for all known services in the service registry:
    istioctl authn tls-check

    # Check settings for a specific service
    istioctl authn tls-check foo.bar.svc.cluster.local

## istioctl deregister

De-registers a service instance

    istioctl deregister <svcname> <ip> [flags]

Flags | Shorthand | Description
--- | --- | ---
`--context <string>` |  | The name of the kubeconfig context to use (default ``)
`--istioNamespace <string>` | `-i` | Istio system namespace (default `istio-system`)
`--kubeconfig <string>` | `-c` | Kubernetes configuration file (default ``)
`--log_as_json` |  | Whether to format output as JSON or in plain console-friendly format
`--log_caller <string>` |  | Comma-separated list of scopes for which to include caller information, scopes can be any of [ads, default, kube-converter, meshconfig, model, rbac] (default ``)
`--log_output_level <string>` |  | Comma-separated minimum per-scope logging level of messages to output, in the form of <scope>:<level>,<scope>:<level>,... where scope can be one of [ads, default, kube-converter, meshconfig, model, rbac] and level can be one of [debug, info, warn, error, fatal, none] (default `default:info`)
`--log_rotate <string>` |  | The path for the optional rotating log file (default ``)
`--log_rotate_max_age <int>` |  | The maximum age in days of a log file beyond which the file is rotated (0 indicates no limit) (default `30`)
`--log_rotate_max_backups <int>` |  | The maximum number of log file backups to keep before older files are deleted (0 indicates no limit) (default `1000`)
`--log_rotate_max_size <int>` |  | The maximum size in megabytes of a log file beyond which the file is rotated (default `104857600`)
`--log_stacktrace_level <string>` |  | Comma-separated minimum per-scope logging level at which stack traces are captured, in the form of <scope>:<level>,<scope:level>,... where scope can be one of [ads, default, kube-converter, meshconfig, model, rbac] and level can be one of [debug, info, warn, error, fatal, none] (default `default:none`)
`--log_target <stringArray>` |  | The set of paths where to output the log. This can be any path as well as the special values stdout and stderr (default `[stdout]`)
`--namespace <string>` | `-n` | Config namespace (default ``)
`--platform <string>` | `-p` | Istio host platform (default `kube`)

### Examples

    # de-register an endpoint 172.17.0.2 from service my-svc:
    istioctl deregister my-svc 172.17.0.2

## istioctl experimental

Experimental commands that may be modified or deprecated

Flags | Shorthand | Description
--- | --- | ---
`--context <string>` |  | The name of the kubeconfig context to use (default ``)
`--istioNamespace <string>` | `-i` | Istio system namespace (default `istio-system`)
`--kubeconfig <string>` | `-c` | Kubernetes configuration file (default ``)
`--log_as_json` |  | Whether to format output as JSON or in plain console-friendly format
`--log_caller <string>` |  | Comma-separated list of scopes for which to include caller information, scopes can be any of [ads, default, kube-converter, meshconfig, model, rbac] (default ``)
`--log_output_level <string>` |  | Comma-separated minimum per-scope logging level of messages to output, in the form of <scope>:<level>,<scope>:<level>,... where scope can be one of [ads, default, kube-converter, meshconfig, model, rbac] and level can be one of [debug, info, warn, error, fatal, none] (default `default:info`)
`--log_rotate <string>` |  | The path for the optional rotating log file (default ``)
`--log_rotate_max_age <int>` |  | The maximum age in days of a log file beyond which the file is rotated (0 indicates no limit) (default `30`)
`--log_rotate_max_backups <int>` |  | The maximum number of log file backups to keep before older files are deleted (0 indicates no limit) (default `1000`)
`--log_rotate_max_size <int>` |  | The maximum size in megabytes of a log file beyond which the file is rotated (default `104857600`)
`--log_stacktrace_level <string>` |  | Comma-separated minimum per-scope logging level at which stack traces are captured, in the form of <scope>:<level>,<scope:level>,... where scope can be one of [ads, default, kube-converter, meshconfig, model, rbac] and level can be one of [debug, info, warn, error, fatal, none] (default `default:none`)
`--log_target <stringArray>` |  | The set of paths where to output the log. This can be any path as well as the special values stdout and stderr (default `[stdout]`)
`--namespace <string>` | `-n` | Config namespace (default ``)
`--platform <string>` | `-p` | Istio host platform (default `kube`)

## istioctl experimental convert-ingress

Converts Ingresses into VirtualService configuration on a best effort basis. The output should be considered a starting point for your Istio configuration and probably require some minor modification. Warnings will be generated where configs cannot be converted perfectly. The input must be a Kubernetes Ingress. The conversion of v1alpha1 Istio rules has been removed from istioctl.

    istioctl experimental convert-ingress [flags]

Flags | Shorthand | Description
--- | --- | ---
`--context <string>` |  | The name of the kubeconfig context to use (default ``)
`--filenames <stringSlice>` | `-f` | Input filenames (default `[]`)
`--istioNamespace <string>` | `-i` | Istio system namespace (default `istio-system`)
`--kubeconfig <string>` | `-c` | Kubernetes configuration file (default ``)
`--log_as_json` |  | Whether to format output as JSON or in plain console-friendly format
`--log_caller <string>` |  | Comma-separated list of scopes for which to include caller information, scopes can be any of [ads, default, kube-converter, meshconfig, model, rbac] (default ``)
`--log_output_level <string>` |  | Comma-separated minimum per-scope logging level of messages to output, in the form of <scope>:<level>,<scope>:<level>,... where scope can be one of [ads, default, kube-converter, meshconfig, model, rbac] and level can be one of [debug, info, warn, error, fatal, none] (default `default:info`)
`--log_rotate <string>` |  | The path for the optional rotating log file (default ``)
`--log_rotate_max_age <int>` |  | The maximum age in days of a log file beyond which the file is rotated (0 indicates no limit) (default `30`)
`--log_rotate_max_backups <int>` |  | The maximum number of log file backups to keep before older files are deleted (0 indicates no limit) (default `1000`)
`--log_rotate_max_size <int>` |  | The maximum size in megabytes of a log file beyond which the file is rotated (default `104857600`)
`--log_stacktrace_level <string>` |  | Comma-separated minimum per-scope logging level at which stack traces are captured, in the form of <scope>:<level>,<scope:level>,... where scope can be one of [ads, default, kube-converter, meshconfig, model, rbac] and level can be one of [debug, info, warn, error, fatal, none] (default `default:none`)
`--log_target <stringArray>` |  | The set of paths where to output the log. This can be any path as well as the special values stdout and stderr (default `[stdout]`)
`--namespace <string>` | `-n` | Config namespace (default ``)
`--output <string>` | `-o` | Output filename (default `-`)
`--platform <string>` | `-p` | Istio host platform (default `kube`)

### Examples

    istioctl experimental convert-ingress -f samples/bookinfo/platform/kube/bookinfo-ingress.yaml

## istioctl experimental metrics

Prints the metrics for the specified service(s) when running in Kubernetes.

This command finds a Prometheus pod running in the specified istio system namespace. It then executes a series of queries per requested workload to find the following top-level workload metrics: total requests per second, error rate, and request latency at p50, p90, and p99 percentiles. The query results are printed to the console, organized by workload name.

All metrics returned are from server-side reports. This means that latencies and error rates are from the perspective of the service itself and not of an individual client (or aggregate set of clients). Rates and latencies are calculated over a time interval of 1 minute.

    istioctl experimental metrics <workload name>...

m

Flags | Shorthand | Description
--- | --- | ---
`--context <string>` |  | The name of the kubeconfig context to use (default ``)
`--istioNamespace <string>` | `-i` | Istio system namespace (default `istio-system`)
`--kubeconfig <string>` | `-c` | Kubernetes configuration file (default ``)
`--log_as_json` |  | Whether to format output as JSON or in plain console-friendly format
`--log_caller <string>` |  | Comma-separated list of scopes for which to include caller information, scopes can be any of [ads, default, kube-converter, meshconfig, model, rbac] (default ``)
`--log_output_level <string>` |  | Comma-separated minimum per-scope logging level of messages to output, in the form of <scope>:<level>,<scope>:<level>,... where scope can be one of [ads, default, kube-converter, meshconfig, model, rbac] and level can be one of [debug, info, warn, error, fatal, none] (default `default:info`)
`--log_rotate <string>` |  | The path for the optional rotating log file (default ``)
`--log_rotate_max_age <int>` |  | The maximum age in days of a log file beyond which the file is rotated (0 indicates no limit) (default `30`)
`--log_rotate_max_backups <int>` |  | The maximum number of log file backups to keep before older files are deleted (0 indicates no limit) (default `1000`)
`--log_rotate_max_size <int>` |  | The maximum size in megabytes of a log file beyond which the file is rotated (default `104857600`)
`--log_stacktrace_level <string>` |  | Comma-separated minimum per-scope logging level at which stack traces are captured, in the form of <scope>:<level>,<scope:level>,... where scope can be one of [ads, default, kube-converter, meshconfig, model, rbac] and level can be one of [debug, info, warn, error, fatal, none] (default `default:none`)
`--log_target <stringArray>` |  | The set of paths where to output the log. This can be any path as well as the special values stdout and stderr (default `[stdout]`)
`--namespace <string>` | `-n` | Config namespace (default ``)
`--platform <string>` | `-p` | Istio host platform (default `kube`)

### Examples

    # Retrieve workload metrics for productpage-v1 workload
    istioctl experimental metrics productpage-v1

    # Retrieve workload metrics for various services in the different namespaces
    istioctl experimental metrics productpage-v1.foo reviews-v1.bar ratings-v1.baz

## istioctl experimental rbac

A group of commands used to interact with Istio RBAC policies. For example, Query whether a specific request is allowed or denied under the current Istio RBAC policies.

Flags | Shorthand | Description
--- | --- | ---
`--context <string>` |  | The name of the kubeconfig context to use (default ``)
`--istioNamespace <string>` | `-i` | Istio system namespace (default `istio-system`)
`--kubeconfig <string>` | `-c` | Kubernetes configuration file (default ``)
`--log_as_json` |  | Whether to format output as JSON or in plain console-friendly format
`--log_caller <string>` |  | Comma-separated list of scopes for which to include caller information, scopes can be any of [ads, default, kube-converter, meshconfig, model, rbac] (default ``)
`--log_output_level <string>` |  | Comma-separated minimum per-scope logging level of messages to output, in the form of <scope>:<level>,<scope>:<level>,... where scope can be one of [ads, default, kube-converter, meshconfig, model, rbac] and level can be one of [debug, info, warn, error, fatal, none] (default `default:info`)
`--log_rotate <string>` |  | The path for the optional rotating log file (default ``)
`--log_rotate_max_age <int>` |  | The maximum age in days of a log file beyond which the file is rotated (0 indicates no limit) (default `30`)
`--log_rotate_max_backups <int>` |  | The maximum number of log file backups to keep before older files are deleted (0 indicates no limit) (default `1000`)
`--log_rotate_max_size <int>` |  | The maximum size in megabytes of a log file beyond which the file is rotated (default `104857600`)
`--log_stacktrace_level <string>` |  | Comma-separated minimum per-scope logging level at which stack traces are captured, in the form of <scope>:<level>,<scope:level>,... where scope can be one of [ads, default, kube-converter, meshconfig, model, rbac] and level can be one of [debug, info, warn, error, fatal, none] (default `default:none`)
`--log_target <stringArray>` |  | The set of paths where to output the log. This can be any path as well as the special values stdout and stderr (default `[stdout]`)
`--namespace <string>` | `-n` | Config namespace (default ``)
`--platform <string>` | `-p` | Istio host platform (default `kube`)

### Examples

    # Query if user test is allowed to GET /v1/health of service rating.
    istioctl experimental rbac can -u test GET rating /v1/health

## istioctl experimental rbac can

This command lets you query whether a specific request will be allowed or denied under current Istio RBAC policies. It constructs a fake request with the custom subject and action specified in the command line to check if your Istio RBAC policies are working as expected. Note the fake request is only used locally to evaluate the effect of the Istio RBAC policies, no actual request will be issued.

METHOD is the HTTP method being taken, like GET, POST, etc. SERVICE is the short service name the action is being taken on. PATH is the HTTP path within the service.

    istioctl experimental rbac can METHOD SERVICE PATH [flags]

Flags | Shorthand | Description
--- | --- | ---
`--action-properties <stringArray>` | `-a` | [Action] Additional data about the action. Specified as name1=value1,name2=value2,... (default `[]`)
`--context <string>` |  | The name of the kubeconfig context to use (default ``)
`--istioNamespace <string>` | `-i` | Istio system namespace (default `istio-system`)
`--kubeconfig <string>` | `-c` | Kubernetes configuration file (default ``)
`--log_as_json` |  | Whether to format output as JSON or in plain console-friendly format
`--log_caller <string>` |  | Comma-separated list of scopes for which to include caller information, scopes can be any of [ads, default, kube-converter, meshconfig, model, rbac] (default ``)
`--log_output_level <string>` |  | Comma-separated minimum per-scope logging level of messages to output, in the form of <scope>:<level>,<scope>:<level>,... where scope can be one of [ads, default, kube-converter, meshconfig, model, rbac] and level can be one of [debug, info, warn, error, fatal, none] (default `default:info`)
`--log_rotate <string>` |  | The path for the optional rotating log file (default ``)
`--log_rotate_max_age <int>` |  | The maximum age in days of a log file beyond which the file is rotated (0 indicates no limit) (default `30`)
`--log_rotate_max_backups <int>` |  | The maximum number of log file backups to keep before older files are deleted (0 indicates no limit) (default `1000`)
`--log_rotate_max_size <int>` |  | The maximum size in megabytes of a log file beyond which the file is rotated (default `104857600`)
`--log_stacktrace_level <string>` |  | Comma-separated minimum per-scope logging level at which stack traces are captured, in the form of <scope>:<level>,<scope:level>,... where scope can be one of [ads, default, kube-converter, meshconfig, model, rbac] and level can be one of [debug, info, warn, error, fatal, none] (default `default:none`)
`--log_target <stringArray>` |  | The set of paths where to output the log. This can be any path as well as the special values stdout and stderr (default `[stdout]`)
`--namespace <string>` | `-n` | Config namespace (default ``)
`--platform <string>` | `-p` | Istio host platform (default `kube`)
`--subject-properties <stringArray>` | `-s` | [Subject] Additional data about the subject. Specified as name1=value1,name2=value2,... (default `[]`)
`--user <string>` | `-u` | [Subject] User name/ID that the subject represents. (default ``)

### Examples

    # Query if user "cluster.local/ns/default/sa/productpage" is allowed to GET /v1/health of service rating.
    istioctl experimental rbac can -u cluster.local/ns/default/sa/productpage GET rating /v1/health

    # Query if namespace foo is allowed to POST to /data of service rating with label version=dev.
    istioctl experimental rbac can -s source.namespace=foo POST rating /data -a destination.labels[version]=dev

## istioctl experimental verify-install

verify-install Verifies Istio Installation Status

    istioctl experimental verify-install [flags]

Flags | Shorthand | Description
--- | --- | ---
`--context <string>` |  | The name of the kubeconfig context to use (default ``)
`--filename <stringSlice>` | `-f` | (default `[]`)
`--istioNamespace <string>` | `-i` | Istio system namespace (default `istio-system`)
`--kubeconfig <string>` | `-c` | Kubernetes configuration file (default ``)
`--log_as_json` |  | Whether to format output as JSON or in plain console-friendly format
`--log_caller <string>` |  | Comma-separated list of scopes for which to include caller information, scopes can be any of [ads, default, kube-converter, meshconfig, model, rbac] (default ``)
`--log_output_level <string>` |  | Comma-separated minimum per-scope logging level of messages to output, in the form of <scope>:<level>,<scope>:<level>,... where scope can be one of [ads, default, kube-converter, meshconfig, model, rbac] and level can be one of [debug, info, warn, error, fatal, none] (default `default:info`)
`--log_rotate <string>` |  | The path for the optional rotating log file (default ``)
`--log_rotate_max_age <int>` |  | The maximum age in days of a log file beyond which the file is rotated (0 indicates no limit) (default `30`)
`--log_rotate_max_backups <int>` |  | The maximum number of log file backups to keep before older files are deleted (0 indicates no limit) (default `1000`)
`--log_rotate_max_size <int>` |  | The maximum size in megabytes of a log file beyond which the file is rotated (default `104857600`)
`--log_stacktrace_level <string>` |  | Comma-separated minimum per-scope logging level at which stack traces are captured, in the form of <scope>:<level>,<scope:level>,... where scope can be one of [ads, default, kube-converter, meshconfig, model, rbac] and level can be one of [debug, info, warn, error, fatal, none] (default `default:none`)
`--log_target <stringArray>` |  | The set of paths where to output the log. This can be any path as well as the special values stdout and stderr (default `[stdout]`)
`--namespace <string>` | `-n` | Config namespace (default ``)
`--platform <string>` | `-p` | Istio host platform (default `kube`)
`--recursive` | `-R` | Process the directory used in -f, --filename recursively. Useful when you want to manage related manifests organized within the same directory.

### Examples

    istioctl verify-install -f istio-demo.yaml

## istioctl kube-inject

kube-inject manually injects envoy sidecar into kubernetes workloads. Unsupported resources are left unmodified so it is safe to run kube-inject over a single file that contains multiple Service, ConfigMap, Deployment, etc. definitions for a complex application. Its best to do this when the resource is initially created.

k8s.io/docs/concepts/workloads/pods/pod-overview/#pod-templates is updated for Job, DaemonSet, ReplicaSet, Pod and Deployment YAML resource documents. Support for additional pod-based resource types can be added as necessary.

The Istio project is continually evolving so the Istio sidecar configuration may change unannounced. When in doubt re-run istioctl kube-inject on deployments to get the most up-to-date changes.

To override the sidecar injection template built into istioctl, the parameters --injectConfigFile or --injectConfigMapName can be used. Both options override any other template configuration parameters, eg. --hub and --tag. These options would typically be used with the file/configmap created with a new Istio release.

    istioctl kube-inject [flags]

Flags | Shorthand | Description
--- | --- | ---
`--context <string>` |  | The name of the kubeconfig context to use (default ``)
`--filename <string>` | `-f` | Input Kubernetes resource filename (default ``)
`--injectConfigFile <string>` |  | injection configuration filename. Cannot be used with --injectConfigMapName (default ``)
`--injectConfigMapName <string>` |  | ConfigMap name for Istio sidecar injection, key should be "config".This option overrides any other sidecar injection config options, eg. --hub (default `istio-sidecar-injector`)
`--istioNamespace <string>` | `-i` | Istio system namespace (default `istio-system`)
`--kubeconfig <string>` | `-c` | Kubernetes configuration file (default ``)
`--log_as_json` |  | Whether to format output as JSON or in plain console-friendly format
`--log_caller <string>` |  | Comma-separated list of scopes for which to include caller information, scopes can be any of [ads, default, kube-converter, meshconfig, model, rbac] (default ``)
`--log_output_level <string>` |  | Comma-separated minimum per-scope logging level of messages to output, in the form of <scope>:<level>,<scope>:<level>,... where scope can be one of [ads, default, kube-converter, meshconfig, model, rbac] and level can be one of [debug, info, warn, error, fatal, none] (default `default:info`)
`--log_rotate <string>` |  | The path for the optional rotating log file (default ``)
`--log_rotate_max_age <int>` |  | The maximum age in days of a log file beyond which the file is rotated (0 indicates no limit) (default `30`)
`--log_rotate_max_backups <int>` |  | The maximum number of log file backups to keep before older files are deleted (0 indicates no limit) (default `1000`)
`--log_rotate_max_size <int>` |  | The maximum size in megabytes of a log file beyond which the file is rotated (default `104857600`)
`--log_stacktrace_level <string>` |  | Comma-separated minimum per-scope logging level at which stack traces are captured, in the form of <scope>:<level>,<scope:level>,... where scope can be one of [ads, default, kube-converter, meshconfig, model, rbac] and level can be one of [debug, info, warn, error, fatal, none] (default `default:none`)
`--log_target <stringArray>` |  | The set of paths where to output the log. This can be any path as well as the special values stdout and stderr (default `[stdout]`)
`--meshConfigFile <string>` |  | mesh configuration filename. Takes precedence over --meshConfigMapName if set (default ``)
`--meshConfigMapName <string>` |  | ConfigMap name for Istio mesh configuration, key should be "mesh" (default `istio`)
`--namespace <string>` | `-n` | Config namespace (default ``)
`--output <string>` | `-o` | Modified output Kubernetes resource filename (default ``)
`--platform <string>` | `-p` | Istio host platform (default `kube`)
`--readinessFailureThreshold <uint32>` |  | The threshold for successive failed readiness probes. (default `30`)
`--readinessInitialDelaySeconds <uint32>` |  | The initial delay (in seconds) for the readiness probe. (default `1`)
`--readinessPeriodSeconds <uint32>` |  | The period between readiness probes (in seconds). (default `2`)
`--rewriteAppProbe` |  | Whether injector rewrites the liveness health check to let kubelet health check the app when mtls is on.
`--statusPort <int>` |  | HTTP Port on which to serve pilot agent status. The path /healthz/ can be used for health checking. If zero, agent status will not be provided. (default `15020`)

### Examples

    # Update resources on the fly before applying.
    kubectl apply -f <(istioctl kube-inject -f <resource.yaml>)

    # Create a persistent version of the deployment with Envoy sidecar
    # injected.
    istioctl kube-inject -f deployment.yaml -o deployment-injected.yaml

    # Update an existing deployment.
    kubectl get deployment -o yaml | istioctl kube-inject -f - | kubectl apply -f -

    # Create a persistent version of the deployment with Envoy sidecar
    # injected configuration from kubernetes configmap 'istio-inject'
    istioctl kube-inject -f deployment.yaml -o deployment-injected.yaml --injectConfigMapName istio-inject

## istioctl proxy-config

A group of commands used to retrieve information about proxy configuration from the Envoy config dump

pc

Flags | Shorthand | Description
--- | --- | ---
`--context <string>` |  | The name of the kubeconfig context to use (default ``)
`--istioNamespace <string>` | `-i` | Istio system namespace (default `istio-system`)
`--kubeconfig <string>` | `-c` | Kubernetes configuration file (default ``)
`--log_as_json` |  | Whether to format output as JSON or in plain console-friendly format
`--log_caller <string>` |  | Comma-separated list of scopes for which to include caller information, scopes can be any of [ads, default, kube-converter, meshconfig, model, rbac] (default ``)
`--log_output_level <string>` |  | Comma-separated minimum per-scope logging level of messages to output, in the form of <scope>:<level>,<scope>:<level>,... where scope can be one of [ads, default, kube-converter, meshconfig, model, rbac] and level can be one of [debug, info, warn, error, fatal, none] (default `default:info`)
`--log_rotate <string>` |  | The path for the optional rotating log file (default ``)
`--log_rotate_max_age <int>` |  | The maximum age in days of a log file beyond which the file is rotated (0 indicates no limit) (default `30`)
`--log_rotate_max_backups <int>` |  | The maximum number of log file backups to keep before older files are deleted (0 indicates no limit) (default `1000`)
`--log_rotate_max_size <int>` |  | The maximum size in megabytes of a log file beyond which the file is rotated (default `104857600`)
`--log_stacktrace_level <string>` |  | Comma-separated minimum per-scope logging level at which stack traces are captured, in the form of <scope>:<level>,<scope:level>,... where scope can be one of [ads, default, kube-converter, meshconfig, model, rbac] and level can be one of [debug, info, warn, error, fatal, none] (default `default:none`)
`--log_target <stringArray>` |  | The set of paths where to output the log. This can be any path as well as the special values stdout and stderr (default `[stdout]`)
`--namespace <string>` | `-n` | Config namespace (default ``)
`--output <string>` | `-o` | Output format: one of json|short (default `short`)
`--platform <string>` | `-p` | Istio host platform (default `kube`)

### Examples

      # Retrieve information about proxy configuration from an Envoy instance.
      istioctl proxy-config <clusters|listeners|routes|endpoints|bootstrap> <pod-name[.namespace]>

## istioctl proxy-config bootstrap

Retrieve information about bootstrap configuration for the Envoy instance in the specified pod.

    istioctl proxy-config bootstrap <pod-name[.namespace]> [flags]

b

Flags | Shorthand | Description
--- | --- | ---
`--context <string>` |  | The name of the kubeconfig context to use (default ``)
`--istioNamespace <string>` | `-i` | Istio system namespace (default `istio-system`)
`--kubeconfig <string>` | `-c` | Kubernetes configuration file (default ``)
`--log_as_json` |  | Whether to format output as JSON or in plain console-friendly format
`--log_caller <string>` |  | Comma-separated list of scopes for which to include caller information, scopes can be any of [ads, default, kube-converter, meshconfig, model, rbac] (default ``)
`--log_output_level <string>` |  | Comma-separated minimum per-scope logging level of messages to output, in the form of <scope>:<level>,<scope>:<level>,... where scope can be one of [ads, default, kube-converter, meshconfig, model, rbac] and level can be one of [debug, info, warn, error, fatal, none] (default `default:info`)
`--log_rotate <string>` |  | The path for the optional rotating log file (default ``)
`--log_rotate_max_age <int>` |  | The maximum age in days of a log file beyond which the file is rotated (0 indicates no limit) (default `30`)
`--log_rotate_max_backups <int>` |  | The maximum number of log file backups to keep before older files are deleted (0 indicates no limit) (default `1000`)
`--log_rotate_max_size <int>` |  | The maximum size in megabytes of a log file beyond which the file is rotated (default `104857600`)
`--log_stacktrace_level <string>` |  | Comma-separated minimum per-scope logging level at which stack traces are captured, in the form of <scope>:<level>,<scope:level>,... where scope can be one of [ads, default, kube-converter, meshconfig, model, rbac] and level can be one of [debug, info, warn, error, fatal, none] (default `default:none`)
`--log_target <stringArray>` |  | The set of paths where to output the log. This can be any path as well as the special values stdout and stderr (default `[stdout]`)
`--namespace <string>` | `-n` | Config namespace (default ``)
`--output <string>` | `-o` | Output format: one of json|short (default `short`)
`--platform <string>` | `-p` | Istio host platform (default `kube`)

### Examples

      # Retrieve full bootstrap configuration for a given pod from Envoy.
      istioctl proxy-config bootstrap <pod-name[.namespace]>

## istioctl proxy-config cluster

Retrieve information about cluster configuration for the Envoy instance in the specified pod.

    istioctl proxy-config cluster <pod-name[.namespace]> [flags]

clustersc

Flags | Shorthand | Description
--- | --- | ---
`--context <string>` |  | The name of the kubeconfig context to use (default ``)
`--direction <string>` |  | Filter clusters by Direction field (default ``)
`--fqdn <string>` |  | Filter clusters by substring of Service FQDN field (default ``)
`--istioNamespace <string>` | `-i` | Istio system namespace (default `istio-system`)
`--kubeconfig <string>` | `-c` | Kubernetes configuration file (default ``)
`--log_as_json` |  | Whether to format output as JSON or in plain console-friendly format
`--log_caller <string>` |  | Comma-separated list of scopes for which to include caller information, scopes can be any of [ads, default, kube-converter, meshconfig, model, rbac] (default ``)
`--log_output_level <string>` |  | Comma-separated minimum per-scope logging level of messages to output, in the form of <scope>:<level>,<scope>:<level>,... where scope can be one of [ads, default, kube-converter, meshconfig, model, rbac] and level can be one of [debug, info, warn, error, fatal, none] (default `default:info`)
`--log_rotate <string>` |  | The path for the optional rotating log file (default ``)
`--log_rotate_max_age <int>` |  | The maximum age in days of a log file beyond which the file is rotated (0 indicates no limit) (default `30`)
`--log_rotate_max_backups <int>` |  | The maximum number of log file backups to keep before older files are deleted (0 indicates no limit) (default `1000`)
`--log_rotate_max_size <int>` |  | The maximum size in megabytes of a log file beyond which the file is rotated (default `104857600`)
`--log_stacktrace_level <string>` |  | Comma-separated minimum per-scope logging level at which stack traces are captured, in the form of <scope>:<level>,<scope:level>,... where scope can be one of [ads, default, kube-converter, meshconfig, model, rbac] and level can be one of [debug, info, warn, error, fatal, none] (default `default:none`)
`--log_target <stringArray>` |  | The set of paths where to output the log. This can be any path as well as the special values stdout and stderr (default `[stdout]`)
`--namespace <string>` | `-n` | Config namespace (default ``)
`--output <string>` | `-o` | Output format: one of json|short (default `short`)
`--platform <string>` | `-p` | Istio host platform (default `kube`)
`--port <int>` |  | Filter clusters by Port field (default `0`)
`--subset <string>` |  | Filter clusters by substring of Subset field (default ``)

### Examples

      # Retrieve summary about cluster configuration for a given pod from Envoy.
      istioctl proxy-config clusters <pod-name[.namespace]>

      # Retrieve cluster summary for clusters with port 9080.
      istioctl proxy-config clusters <pod-name[.namespace]> --port 9080

      # Retrieve full cluster dump for clusters that are inbound with a FQDN of details.default.svc.cluster.local.
      istioctl proxy-config clusters <pod-name[.namespace]> --fqdn details.default.svc.cluster.local --direction inbound -o json

## istioctl proxy-config endpoint

Retrieve information about endpoint configuration for the Envoy instance in the specified pod.

    istioctl proxy-config endpoint <pod-name[.namespace]> [flags]

endpointsep

Flags | Shorthand | Description
--- | --- | ---
`--address <string>` |  | Filter endpoints by address field (default ``)
`--cluster <string>` |  | Filter endpoints by cluster name field (default ``)
`--context <string>` |  | The name of the kubeconfig context to use (default ``)
`--istioNamespace <string>` | `-i` | Istio system namespace (default `istio-system`)
`--kubeconfig <string>` | `-c` | Kubernetes configuration file (default ``)
`--log_as_json` |  | Whether to format output as JSON or in plain console-friendly format
`--log_caller <string>` |  | Comma-separated list of scopes for which to include caller information, scopes can be any of [ads, default, kube-converter, meshconfig, model, rbac] (default ``)
`--log_output_level <string>` |  | Comma-separated minimum per-scope logging level of messages to output, in the form of <scope>:<level>,<scope>:<level>,... where scope can be one of [ads, default, kube-converter, meshconfig, model, rbac] and level can be one of [debug, info, warn, error, fatal, none] (default `default:info`)
`--log_rotate <string>` |  | The path for the optional rotating log file (default ``)
`--log_rotate_max_age <int>` |  | The maximum age in days of a log file beyond which the file is rotated (0 indicates no limit) (default `30`)
`--log_rotate_max_backups <int>` |  | The maximum number of log file backups to keep before older files are deleted (0 indicates no limit) (default `1000`)
`--log_rotate_max_size <int>` |  | The maximum size in megabytes of a log file beyond which the file is rotated (default `104857600`)
`--log_stacktrace_level <string>` |  | Comma-separated minimum per-scope logging level at which stack traces are captured, in the form of <scope>:<level>,<scope:level>,... where scope can be one of [ads, default, kube-converter, meshconfig, model, rbac] and level can be one of [debug, info, warn, error, fatal, none] (default `default:none`)
`--log_target <stringArray>` |  | The set of paths where to output the log. This can be any path as well as the special values stdout and stderr (default `[stdout]`)
`--namespace <string>` | `-n` | Config namespace (default ``)
`--output <string>` | `-o` | Output format: one of json|short (default `short`)
`--platform <string>` | `-p` | Istio host platform (default `kube`)
`--port <int>` |  | Filter endpoints by Port field (default `0`)
`--status <string>` |  | Filter endpoints by status field (default ``)

### Examples

      # Retrieve full endpoint configuration for a given pod from Envoy.
      istioctl proxy-config endpoint <pod-name[.namespace]>

      # Retrieve endpoint summary for endpoint with port 9080.
      istioctl proxy-config endpoint <pod-name[.namespace]> --port 9080

      # Retrieve full endpoint with a address (172.17.0.2).
      istioctl proxy-config endpoint <pod-name[.namespace]> --address 172.17.0.2 -o json

      # Retrieve full endpoint with a cluster name (outbound|9411||zipkin.istio-system.svc.cluster.local).
      istioctl proxy-config endpoint <pod-name[.namespace]> --cluster "outbound|9411||zipkin.istio-system.svc.cluster.local" -o json
      # Retrieve full endpoint with the status (healthy).
      istioctl proxy-config endpoint <pod-name[.namespace]> --status healthy -ojson

## istioctl proxy-config listener

Retrieve information about listener configuration for the Envoy instance in the specified pod.

    istioctl proxy-config listener <pod-name[.namespace]> [flags]

listenersl

Flags | Shorthand | Description
--- | --- | ---
`--address <string>` |  | Filter listeners by address field (default ``)
`--context <string>` |  | The name of the kubeconfig context to use (default ``)
`--istioNamespace <string>` | `-i` | Istio system namespace (default `istio-system`)
`--kubeconfig <string>` | `-c` | Kubernetes configuration file (default ``)
`--log_as_json` |  | Whether to format output as JSON or in plain console-friendly format
`--log_caller <string>` |  | Comma-separated list of scopes for which to include caller information, scopes can be any of [ads, default, kube-converter, meshconfig, model, rbac] (default ``)
`--log_output_level <string>` |  | Comma-separated minimum per-scope logging level of messages to output, in the form of <scope>:<level>,<scope>:<level>,... where scope can be one of [ads, default, kube-converter, meshconfig, model, rbac] and level can be one of [debug, info, warn, error, fatal, none] (default `default:info`)
`--log_rotate <string>` |  | The path for the optional rotating log file (default ``)
`--log_rotate_max_age <int>` |  | The maximum age in days of a log file beyond which the file is rotated (0 indicates no limit) (default `30`)
`--log_rotate_max_backups <int>` |  | The maximum number of log file backups to keep before older files are deleted (0 indicates no limit) (default `1000`)
`--log_rotate_max_size <int>` |  | The maximum size in megabytes of a log file beyond which the file is rotated (default `104857600`)
`--log_stacktrace_level <string>` |  | Comma-separated minimum per-scope logging level at which stack traces are captured, in the form of <scope>:<level>,<scope:level>,... where scope can be one of [ads, default, kube-converter, meshconfig, model, rbac] and level can be one of [debug, info, warn, error, fatal, none] (default `default:none`)
`--log_target <stringArray>` |  | The set of paths where to output the log. This can be any path as well as the special values stdout and stderr (default `[stdout]`)
`--namespace <string>` | `-n` | Config namespace (default ``)
`--output <string>` | `-o` | Output format: one of json|short (default `short`)
`--platform <string>` | `-p` | Istio host platform (default `kube`)
`--port <int>` |  | Filter listeners by Port field (default `0`)
`--type <string>` |  | Filter listeners by type field (default ``)

### Examples

      # Retrieve summary about listener configuration for a given pod from Envoy.
      istioctl proxy-config listeners <pod-name[.namespace]>

      # Retrieve listener summary for listeners with port 9080.
      istioctl proxy-config listeners <pod-name[.namespace]> --port 9080

      # Retrieve full listener dump for HTTP listeners with a wildcard address (0.0.0.0).
      istioctl proxy-config listeners <pod-name[.namespace]> --type HTTP --address 0.0.0.0 -o json

## istioctl proxy-config route

Retrieve information about route configuration for the Envoy instance in the specified pod.

    istioctl proxy-config route <pod-name[.namespace]> [flags]

routesr

Flags | Shorthand | Description
--- | --- | ---
`--context <string>` |  | The name of the kubeconfig context to use (default ``)
`--istioNamespace <string>` | `-i` | Istio system namespace (default `istio-system`)
`--kubeconfig <string>` | `-c` | Kubernetes configuration file (default ``)
`--log_as_json` |  | Whether to format output as JSON or in plain console-friendly format
`--log_caller <string>` |  | Comma-separated list of scopes for which to include caller information, scopes can be any of [ads, default, kube-converter, meshconfig, model, rbac] (default ``)
`--log_output_level <string>` |  | Comma-separated minimum per-scope logging level of messages to output, in the form of <scope>:<level>,<scope>:<level>,... where scope can be one of [ads, default, kube-converter, meshconfig, model, rbac] and level can be one of [debug, info, warn, error, fatal, none] (default `default:info`)
`--log_rotate <string>` |  | The path for the optional rotating log file (default ``)
`--log_rotate_max_age <int>` |  | The maximum age in days of a log file beyond which the file is rotated (0 indicates no limit) (default `30`)
`--log_rotate_max_backups <int>` |  | The maximum number of log file backups to keep before older files are deleted (0 indicates no limit) (default `1000`)
`--log_rotate_max_size <int>` |  | The maximum size in megabytes of a log file beyond which the file is rotated (default `104857600`)
`--log_stacktrace_level <string>` |  | Comma-separated minimum per-scope logging level at which stack traces are captured, in the form of <scope>:<level>,<scope:level>,... where scope can be one of [ads, default, kube-converter, meshconfig, model, rbac] and level can be one of [debug, info, warn, error, fatal, none] (default `default:none`)
`--log_target <stringArray>` |  | The set of paths where to output the log. This can be any path as well as the special values stdout and stderr (default `[stdout]`)
`--name <string>` |  | Filter listeners by route name field (default ``)
`--namespace <string>` | `-n` | Config namespace (default ``)
`--output <string>` | `-o` | Output format: one of json|short (default `short`)
`--platform <string>` | `-p` | Istio host platform (default `kube`)

### Examples

      # Retrieve summary about route configuration for a given pod from Envoy.
      istioctl proxy-config routes <pod-name[.namespace]>

      # Retrieve route summary for route 9080.
      istioctl proxy-config route <pod-name[.namespace]> --name 9080

      # Retrieve full route dump for route 9080
      istioctl proxy-config route <pod-name[.namespace]> --name 9080 -o json

## istioctl proxy-status

Retrieves last sent and last acknowledged xDS sync from Pilot to each Envoy in the mesh

    istioctl proxy-status [<pod-name[.namespace]>] [flags]

ps

Flags | Shorthand | Description
--- | --- | ---
`--context <string>` |  | The name of the kubeconfig context to use (default ``)
`--istioNamespace <string>` | `-i` | Istio system namespace (default `istio-system`)
`--kubeconfig <string>` | `-c` | Kubernetes configuration file (default ``)
`--log_as_json` |  | Whether to format output as JSON or in plain console-friendly format
`--log_caller <string>` |  | Comma-separated list of scopes for which to include caller information, scopes can be any of [ads, default, kube-converter, meshconfig, model, rbac] (default ``)
`--log_output_level <string>` |  | Comma-separated minimum per-scope logging level of messages to output, in the form of <scope>:<level>,<scope>:<level>,... where scope can be one of [ads, default, kube-converter, meshconfig, model, rbac] and level can be one of [debug, info, warn, error, fatal, none] (default `default:info`)
`--log_rotate <string>` |  | The path for the optional rotating log file (default ``)
`--log_rotate_max_age <int>` |  | The maximum age in days of a log file beyond which the file is rotated (0 indicates no limit) (default `30`)
`--log_rotate_max_backups <int>` |  | The maximum number of log file backups to keep before older files are deleted (0 indicates no limit) (default `1000`)
`--log_rotate_max_size <int>` |  | The maximum size in megabytes of a log file beyond which the file is rotated (default `104857600`)
`--log_stacktrace_level <string>` |  | Comma-separated minimum per-scope logging level at which stack traces are captured, in the form of <scope>:<level>,<scope:level>,... where scope can be one of [ads, default, kube-converter, meshconfig, model, rbac] and level can be one of [debug, info, warn, error, fatal, none] (default `default:none`)
`--log_target <stringArray>` |  | The set of paths where to output the log. This can be any path as well as the special values stdout and stderr (default `[stdout]`)
`--namespace <string>` | `-n` | Config namespace (default ``)
`--platform <string>` | `-p` | Istio host platform (default `kube`)

### Examples

    # Retrieve sync status for all Envoys in a mesh
    	istioctl proxy-status

    # Retrieve sync diff for a single Envoy and Pilot
    	istioctl proxy-status istio-egressgateway-59585c5b9c-ndc59.istio-system

## istioctl register

Registers a service instance (e.g. VM) joining the mesh

    istioctl register <svcname> <ip> [name1:]port1 [name2:]port2 ... [flags]

Flags | Shorthand | Description
--- | --- | ---
`--annotations <stringSlice>` | `-a` | List of string annotations to apply if creating a service/endpoint; e.g. -a foo=bar,test,x=y (default `[]`)
`--context <string>` |  | The name of the kubeconfig context to use (default ``)
`--istioNamespace <string>` | `-i` | Istio system namespace (default `istio-system`)
`--kubeconfig <string>` | `-c` | Kubernetes configuration file (default ``)
`--labels <stringSlice>` | `-l` | List of labels to apply if creating a service/endpoint; e.g. -l env=prod,vers=2 (default `[]`)
`--log_as_json` |  | Whether to format output as JSON or in plain console-friendly format
`--log_caller <string>` |  | Comma-separated list of scopes for which to include caller information, scopes can be any of [ads, default, kube-converter, meshconfig, model, rbac] (default ``)
`--log_output_level <string>` |  | Comma-separated minimum per-scope logging level of messages to output, in the form of <scope>:<level>,<scope>:<level>,... where scope can be one of [ads, default, kube-converter, meshconfig, model, rbac] and level can be one of [debug, info, warn, error, fatal, none] (default `default:info`)
`--log_rotate <string>` |  | The path for the optional rotating log file (default ``)
`--log_rotate_max_age <int>` |  | The maximum age in days of a log file beyond which the file is rotated (0 indicates no limit) (default `30`)
`--log_rotate_max_backups <int>` |  | The maximum number of log file backups to keep before older files are deleted (0 indicates no limit) (default `1000`)
`--log_rotate_max_size <int>` |  | The maximum size in megabytes of a log file beyond which the file is rotated (default `104857600`)
`--log_stacktrace_level <string>` |  | Comma-separated minimum per-scope logging level at which stack traces are captured, in the form of <scope>:<level>,<scope:level>,... where scope can be one of [ads, default, kube-converter, meshconfig, model, rbac] and level can be one of [debug, info, warn, error, fatal, none] (default `default:none`)
`--log_target <stringArray>` |  | The set of paths where to output the log. This can be any path as well as the special values stdout and stderr (default `[stdout]`)
`--namespace <string>` | `-n` | Config namespace (default ``)
`--platform <string>` | `-p` | Istio host platform (default `kube`)
`--serviceaccount <string>` | `-s` | Service account to link to the service (default `default`)

## istioctl validate

Validate Istio policy and rules

    istioctl validate -f FILENAME [options] [flags]

Flags | Shorthand | Description
--- | --- | ---
`--context <string>` |  | The name of the kubeconfig context to use (default ``)
`--filename <stringSlice>` | `-f` | (default `[]`)
`--istioNamespace <string>` | `-i` | Istio system namespace (default `istio-system`)
`--kubeconfig <string>` | `-c` | Kubernetes configuration file (default ``)
`--log_as_json` |  | Whether to format output as JSON or in plain console-friendly format
`--log_caller <string>` |  | Comma-separated list of scopes for which to include caller information, scopes can be any of [ads, default, kube-converter, meshconfig, model, rbac] (default ``)
`--log_output_level <string>` |  | Comma-separated minimum per-scope logging level of messages to output, in the form of <scope>:<level>,<scope>:<level>,... where scope can be one of [ads, default, kube-converter, meshconfig, model, rbac] and level can be one of [debug, info, warn, error, fatal, none] (default `default:info`)
`--log_rotate <string>` |  | The path for the optional rotating log file (default ``)
`--log_rotate_max_age <int>` |  | The maximum age in days of a log file beyond which the file is rotated (0 indicates no limit) (default `30`)
`--log_rotate_max_backups <int>` |  | The maximum number of log file backups to keep before older files are deleted (0 indicates no limit) (default `1000`)
`--log_rotate_max_size <int>` |  | The maximum size in megabytes of a log file beyond which the file is rotated (default `104857600`)
`--log_stacktrace_level <string>` |  | Comma-separated minimum per-scope logging level at which stack traces are captured, in the form of <scope>:<level>,<scope:level>,... where scope can be one of [ads, default, kube-converter, meshconfig, model, rbac] and level can be one of [debug, info, warn, error, fatal, none] (default `default:none`)
`--log_target <stringArray>` |  | The set of paths where to output the log. This can be any path as well as the special values stdout and stderr (default `[stdout]`)
`--namespace <string>` | `-n` | Config namespace (default ``)
`--platform <string>` | `-p` | Istio host platform (default `kube`)
`--recursive` | `-R` | Process the directory used in -f, --filename recursively. Useful when you want to manage related manifests organized within the same directory.

### Examples

    istioctl validate -f bookinfo-gateway.yaml

## istioctl version

Prints out build version information

    istioctl version [flags]

Flags | Shorthand | Description
--- | --- | ---
`--context <string>` |  | The name of the kubeconfig context to use (default ``)
`--istioNamespace <string>` | `-i` | Istio system namespace (default `istio-system`)
`--kubeconfig <string>` | `-c` | Kubernetes configuration file (default ``)
`--log_as_json` |  | Whether to format output as JSON or in plain console-friendly format
`--log_caller <string>` |  | Comma-separated list of scopes for which to include caller information, scopes can be any of [ads, default, kube-converter, meshconfig, model, rbac] (default ``)
`--log_output_level <string>` |  | Comma-separated minimum per-scope logging level of messages to output, in the form of <scope>:<level>,<scope>:<level>,... where scope can be one of [ads, default, kube-converter, meshconfig, model, rbac] and level can be one of [debug, info, warn, error, fatal, none] (default `default:info`)
`--log_rotate <string>` |  | The path for the optional rotating log file (default ``)
`--log_rotate_max_age <int>` |  | The maximum age in days of a log file beyond which the file is rotated (0 indicates no limit) (default `30`)
`--log_rotate_max_backups <int>` |  | The maximum number of log file backups to keep before older files are deleted (0 indicates no limit) (default `1000`)
`--log_rotate_max_size <int>` |  | The maximum size in megabytes of a log file beyond which the file is rotated (default `104857600`)
`--log_stacktrace_level <string>` |  | Comma-separated minimum per-scope logging level at which stack traces are captured, in the form of <scope>:<level>,<scope:level>,... where scope can be one of [ads, default, kube-converter, meshconfig, model, rbac] and level can be one of [debug, info, warn, error, fatal, none] (default `default:none`)
`--log_target <stringArray>` |  | The set of paths where to output the log. This can be any path as well as the special values stdout and stderr (default `[stdout]`)
`--namespace <string>` | `-n` | Config namespace (default ``)
`--output <string>` | `-o` | One of 'yaml' or 'json'. (default ``)
`--platform <string>` | `-p` | Istio host platform (default `kube`)
`--remote` |  | Prints remote version information, from the control plane
`--short` | `-s` | Displays a short form of the version information